;;*****************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
;	Additional Info - Release version  1.8T_05
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, 2004,2005"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************
; Sequenced responses to the Slave Poll, called so that the screen is updated.
;;--- NOTE				;; Feb. 11 2004  (T)
;; Meaning of Displays are little modified to meet "State-transition-model".
;; Since the "Display" is incremented in the next transition process
;; in the original code, I modified to set it in the end of every transition
;;      "Present_State_Num" + "Event" ==>[proc]==> "Next_State_Num"
;;    It's easy to read...

Respond_SlavePoll:			;; [permission to talk]
	movf	MyId, 0			; Check it's the right ID
	xorwf	Rad, 0			;;      Apr. 24 2004 (T)
	btfss	STATUS, Z
	goto	ReceiveBreak		; Done, wait for next command

	clrf	Checksum 		; Clear checksum

	movf	Display, 0
	xorlw	0x01			;; 1/16 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_1

	movf	Display, 0
	xorlw	0x02			;; 1/16 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_2

	movf	Display, 0
	xorlw	0x03			;; 1/16 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_3

	movf	Display, 0
	xorlw	0x04			;; 7/30 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_4

	movf	Display, 0
	xorlw	0x05			;; 7/30 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_5

	movf	Display, 0
	xorlw	0x06			;; 3/4 2004 (T)
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_6

	movf	Display, 0
	xorlw	0x07			;
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_7

	movf	Display, 0
	xorlw	0x08			;
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_8

	movf	Display, 0
	xorlw	0x09			;
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_9

	movf	Display, 0
	xorlw	0x0a			;
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_a

	movf	Display, 0
	xorlw	0x0c			;
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_c

	IFDEF	DiscName_Scrol
;;-------------------------------
	movf	Display, 0
	xorlw	0x0e			;
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_e
;;-------------------------------
	ENDIF

	IFDEF	NextNext
;;--- NEXT NEXT	------------------
	movf	Display, 0
	xorlw	0x10			;; =16
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_10
;;--------------------------------
	ENDIF

	IFDEF	Internal_MD
;;--------------------------------
	movf	Display, 0
	xorlw	0x20			;; =32
	btfsc	STATUS, Z
	goto	Respond_SlavePoll_20
;;--------------------------------
	ENDIF

	goto	ReceiveBreak		; should NEVER get here!!

Respond_SlavePoll_1:
	movlw	0x77			; 'Seeking CD'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xc0
	call	SendByte

	movlw	0x40			;; "LOAD"
	call	SendByte

	call	Checksum_mid

	call	SendByte3_00

	movlw	0x00
	call	SendByte

	movf	MyGroup, 0		;;
	xorlw	0x30
	movlw	0x50            	;; for MD ("0x50":DiscName and TrackName)
	btfsc	STATUS, Z
	movlw	0x40			;; for CD ("0x40":DiscName Only)
	call	SendByte

	clrf	TrackNum		;; initialize TrackNum
	call	TrackNumUpdate		;; generate TrackNum_Dsp

	movf	TrackNum_Dsp, 0		;; Track Number  Feb. 21 2004 (T)
	call	SendByte

	movlw	0x00			;; Min
	call	SendByte

	movlw	0x00			;; Sec
	call	SendByte

	swapf	DiskNum, 0		; Disk Number + disp code
	andlw	0xf0			; mask by 0xf0 (high nibble)
	iorlw	0x01
	call	SendByte

	call	Respond_End_R

	clrf	Timep			;; Time Counter reset (T)
	clrf	Time0			;; 
	clrf	Time1			;; 
	clrf	Time0i			;; 
	clrf	Time1i			;; 

	clrf	DSPL_Run		;; Sep. 23 2004 (T)

	bcf	INTCON, GIE		;; Disable interrupt  Feb. 05 2004 (T)

	call	RelSet_ON		;; Apr. 07 2004 (T)

;;-- Set DispCtrl --
	movf	DisplayMode, 0
	xorlw	Show_Time		;; = 0x09 (Track Time)
	btfsc	STATUS, Z
	goto	TrackTime_Ent

	movf	DisplayMode, 0		;;
	xorlw	Show_DcName		;; check  DisplayMode = DiscName
	movlw	DispCtrl_DcName
	btfsc	STATUS, Z
	movwf	DispCtrl

	movf	DisplayMode, 0		;;
	xorlw	Show_TrName		;; check  DisplayMode = TrackName
	movlw	DispCtrl_TrName
	btfsc	STATUS, Z
	movwf	DispCtrl

	goto	Config_TMR1_2		;; not TrackTime, Skip

TrackTime_Ent:				;; case TrackTime,
	movlw	DispCtrl_DcName
	movwf	DispCtrl	

	bsf	DSPL_Run, 0		;; set DSPL_Run flag ON
	movlw	DiscNamADDR0		;; EEPROM:0x2120
	movwf	DiscNamADDR

Config_TMR1_2:				;; setup TMR0
	movlw	Int1sec_Data	  	;; Int1sec_Data -> Int1sec_Count
	movwf	Int1sec_Count	  	;; (software counter)

	movlw	TMR1H_SetData		;; set TMR1H initial
	movwf	TMR1H

	movlw	TMR1L_SetData		;; set TMR1H initial
	movwf	TMR1L

	bcf	PIR1, TMR1IF		;; clear overflow flag

;;--- Disable Interrpt until DiscName Displaying has been completed  (T)
	bcf	INTCON, GIE		;; Disable GEIE Interrupt
	nop
	bcf	INTCON, PEIE		;; Disable PEIE Interrupt

	bsf	STATUS, RP0		;; go to Bank1
	bcf	PIE1, TMR1IE		;; Disable TMR1 Inerrupt
	bcf	STATUS, RP0		;; back to Bank0

	bcf	T1CON, TMR1ON		;; set TMR1ON = Stop


But_DSPL_Ent2:
	call	Int_Reset

	bsf	DSPL_Run, 1		;; set DSPL_Run = xxxxxx1x
	movlw	0x02			;; Next State Number=2
	movwf	Display

	bsf	ResPeriod, 0		;; (set ResPeriod = 1)
	call	IssueSlaveBreak		;;

	goto	ReceiveBreak


Respond_SlavePoll_2:			
	movlw	0x70			; 'Seeking to Track'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xc0
	call	SendByte

	movlw	0x00			;; 00 Seeking
	call	SendByte

	call	Checksum_mid

	call	SendByte3_00

	movlw	0x00
	call	SendByte

	movf	MyGroup, 0		;;
	xorlw	0x30
	movlw	0x50            	;; for MD ("0x50":DiscName and TrackName)
	btfsc	STATUS, Z
	movlw	0x40			;; for CD ("0x40":DiscName Only)
	call	SendByte
	
	movf	TrackNum_Dsp, 0		;; Track Number Feb. 21 2004 (T)
	call	SendByte

	movf	Time1, 0		; Track Timer  (minutes)
	call	SendByte

	movf	Time0, 0		; Track Timer  (seconds)
	call	SendByte

	swapf	DiskNum, 0		; Disk Number + disp code
	andlw	0xf0			; mask by 0xf0 (high nibble)
	iorwf	DispCtrl, 0
	call	SendByte

	call	Respond_End_R

But_DSPL_Ent:
	call	Int_Reset
	movf	MyGroup, 0		
	xorlw	0x30			;; case CD/MD?
	movlw	0x04			;; Next State Number=4 (MD)
	btfsc	STATUS, Z
	movlw	0x06			;; Next State Number=6 (CD)
	movwf	Display

	bsf	ResPeriod, 0		;; (set ResPeriod = 1)
	call	IssueSlaveBreak		;; call ISB

	goto	ReceiveBreak		; Done, wait for next command

	
Respond_SlavePoll_3:
	clrf	Int1secON		;; June 05 2004 (T)

	movlw	DispCtrl_Inform
	movwf	DispCtrl		

	movlw	0x70			; "CD d, Track t, mm:ss"
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0x90
	call	SendByte

	movf	MyGroup, 0		;;
	xorlw	0x30
	movlw	0x50            	;; for MD ("0x50":DiscName and TrackName)
	btfsc	STATUS, Z
	movlw	0x40			;; for CD ("0x40":DiscName Only)
	call	SendByte

	call	Checksum_mid

	movf	TrackNum_Dsp, 0		;; Track Number   Feb. 21 2004 (T)
	call	SendByte

	movf	Time1, 0		; Track Timer  (minutes)
	call	SendByte

	movf	Time0, 0		; Track Timer  (seconds)
	call	SendByte

	swapf	DiskNum, 0		; Disk Number + Disp code
	andlw	0xf0			; mask by 0xf0 (high nibble)
	iorwf	DispCtrl, 0
	call	SendByte

	call	Respond_End_R

	bcf	INTCON, GIE		;; Disable interrupt  Feb. 05 2004 (T)

	movlw	0x03			;; Next State Number=3
	movwf	Display

;;-- DiscName auto display --
	movf	MyGroup, 0		;; case MD Only.
	xorlw	0x30
	btfsc	STATUS, Z
	goto	SLP3_B			;; case CD, Exit

	movf	DisplayMode, 0		;;
	xorlw	Show_TrName		;; check  DisplayMode = TrackName
	btfsc	STATUS, Z
	goto	SLP3_B			;; case TrackName, Exit

	movf	DisplayMode, 0		;;
	xorlw	Show_DcName		;; check  DisplayMode = DiscName
	btfsc	STATUS, Z
	goto	SLP3_BP			;; case DiscName, Exit

	movf	DisplayMode, 0		;;
	xorlw	Show_Clock		;; check  DisplayMode = Clock
	btfsc	STATUS, Z
	goto	SLP3_B			;; case Clock, Exit

	btfsc	DSPL_Run, 0		;; check DSPL_Run(0)=ON?
	goto	Skip08			;; case ON, Skip08

					;; Else (TrackTime or not defined)
	movf	Time0, 0		; Track Timer  (seconds)
	xorlw	0x00			;; BCD expression "00"
	btfss	STATUS, Z
	goto	Skip09			;; not 00, Skip09

	btfsc	Time1, 0		; check TrackTimer is 0,2,4,6,8,10...
	goto	Skip09			;; Not 0,2,4,6,8,10, Skip09

	movlw	0x08			;; set Display=8
	movwf	Display			;; 
	bsf	DSPL_Run, 0		;; set DSPL_Run flag ON
	call	IssueSlaveBreak
	goto	ReceiveBreak

Skip08:
	movf	Time0, 0		;  Track Timer  (seconds)
	sublw	0x06			;; 0x06 - Time0   (C=0, negative)
	btfsc	STATUS, C		;; 
	goto	Skip09			;; case zero or positive, Skip09

					;; case 7 or over
	movf	Time0, 0		;  Track Timer  (seconds)
	sublw	0x08			;; 0x08 - Time0   (C=0, negative)
	btfss	STATUS, C		;; 
	goto	Skip09			;; case negative(9 or over), Skip09

					;; case DSPL_Run = ON, (Time0=07 or 08)
	movlw	0x09			;; set Display=9
	movwf	Display			;; 
	bsf	DSPL_Run, 2		;; set DSPL_Run(2) flag ON
	call	IssueSlaveBreak	
	goto	ReceiveBreak

Skip09:
	btfss	DSPL_Run, 2		;; check DSPL_Run(2)=ON?
	goto	SLP3_B			;; case OFF, Exit.

	movf	Time0, 0		;  Track Timer  (seconds)

	xorlw	0x53			;; Update Time (every 53sec) (BCD expression) 

	btfss	STATUS, Z
	goto	SLP3_B			;; not 55, Exit.

	movf	Time1, 0
	andlw	0x03
	xorlw	0x03			;; check TrackTimer is 3,7,11,15,...59(min.)
	btfss	STATUS, Z
	goto	Skip091			;; else, Skip

	movlw	DiscNamADDR0		;; EEPROM:0x2120
	movwf	DiscNamADDR
	movlw	TrackNamADDR0		;; EEPROM:0x2140
	movwf	TrackNamADDR
	clrf	DSPL_ToggleC		;; set DSPL_ToggleC = 0 (even)

	bcf	DSPL_Run, 2		;; clear DSPL_Run(2) flag
	goto	But_DSPL_Ent2

Skip091:
	movf	Time1, 0
	andlw	0x03
	xorlw	0x01			;; check TrackTimer is 1,5,9,13,...57(min.)
	btfss	STATUS, Z
	goto	SLP3_B			;; 

	movlw	DiscNamADDR1		;; EEPROM:0x2130
	movwf	DiscNamADDR
	movlw	TrackNamADDR1		;; EEPROM:0x2140
	movwf	TrackNamADDR

;;	bsf	DSPL_ToggleC, 0		;; set DSPL_ToggleC = 1 (odd)

	movlw	0x01			;; 	;; Jun. 30 2005	(T)
	movwf	DSPL_ToggleC		;; set DSPL_ToggleC = 0x01 (odd) 

	bcf	DSPL_Run, 2		;; clear DSPL_Run(2) flag
	goto	But_DSPL_Ent2


SLP3_BP:
	movf	Time0, 0		; Track Timer  (seconds)
	xorlw	0x00			;;
	btfss	STATUS, Z
	goto	SLP3_B

	movf	Time1, 0		; Track Timer  (minutes)
	xorlw	0x00			;;
	btfss	STATUS, Z
	goto	SLP3_B

	btfsc	DSPL_Run, 1
	goto	SLP3_B			;; DSPL_Run(1)=1, goto	SLP3_B

					;; DSPL_Run(1)=0
	clrf	DSPL_Run		;; clear DSPL_Run, 
	goto	But_DSPL_Ent2		;; and, goto But_DSPL_Ent2

SLP3_B:	
	call	Int_Enaset		;; Enable Interrpt

	btfsc	PowDown, 0		;; case Power Down,
	call	Play_Stop		;; Stop Playing
					
	goto	ReceiveBreak		;; else, Continue


Respond_SlavePoll_4:
	movlw	0x70			; 'Track name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xC9
	call	SendByte

	movf	TrackNamADDR, 0		;; TrackNamADDR -> W
	movwf	EepromChrAdd		;; set ;; TrackNamADDR

	call	SendEepromChrs

	movf	TrackNum_Dsp, 0		;; Track Number
	call	SendByte

	movlw	0x00			;; 1st time. (high nibble=0)
	iorwf	DispCtrl, 0		;; 
	andlw	0xf3			;; mask with '11110011'
	call	SendByte

	call	Respond_End_R

	movlw	0x05			;; Next State Number=5
	movwf	Display

	bsf	ResPeriod, 0		;; set ResPeriod=1
	call	IssueSlaveBreak		;; call ISB

	goto	ReceiveBreak		; Done, wait for next command


Respond_SlavePoll_5:
	movlw	0x70				; 'Track name, part2'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xC9
	call	SendByte

	call	SendEepromChrs

	movf	TrackNum_Dsp, 0		;; Track Number   Feb. 21 2004 (T)
	call	SendByte

	movlw	0x10			;; 2nd time. (high nibble=1)
	iorwf	DispCtrl, 0		;; 
	andlw	0xf3			;; mask with '11110011'
	call	SendByte

	call	Respond_End_R

	movlw	0x06			;; Next State Number=6 (CD)
	movwf	Display
	bsf	ResPeriod, 0		;; (set ResPeriod = 1)
	call	IssueSlaveBreak		;; call ISB

	goto	ReceiveBreak		; Done, wait for next command


Respond_SlavePoll_6:
	movlw	0x70			; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xCD
	call	SendByte

	movf	DiscNamADDR, 0		;; DiscNamADDR -> W
	movwf	EepromChrAdd		;; set ;; DiscNamADDR

	call	SendEepromChrs

	movf	DiskNum, 0 		;; Disc Number
	andlw	0x0f			; mask by 0x0f (low nibble)
	call	SendByte

;;--------- for MDX-5V101R, for MDX-61    Mar. 06 2004 (T)
	movlw	0x00			;; 1st time. (high nibble=0)
	iorwf	DispCtrl, 0		;; 
	andlw	0xf3			;; mask with '11110011'
	call	SendByte

	call	Respond_End_R

	movlw	0x07			;; Next State Number=7
	movwf	Display
	bsf	ResPeriod, 0		;; set ResPeriod = 1
	call	IssueSlaveBreak		;; call ISB

	goto	ReceiveBreak		; Done, wait for next command


Respond_SlavePoll_7:
	movlw	0x70			; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xCD
	call	SendByte

	call	SendEepromChrs

	movf	DiskNum, 0 		;; Disc Number
	andlw	0x0f			; mask by 0x0f (low nibble)
	call	SendByte

;;------- for MDX-5V101R, and for MDX-61    Mar. 06 2004 (T)
	movlw	0x10			;; 2st time. (high nibble=1)
	iorwf	DispCtrl, 0		;; 
	andlw	0xf3			;; mask with '11110011'
	call	SendByte

	call	Respond_End_R

DSP_Rt_Ent:
	movf	Display, 0		
	xorlw	0x0e			;; if the Manual Scroll is not completed,
	btfsc	STATUS, Z		;; continue. (set Display=0x0e)
	goto	ManualScrl_Ent

	movf	MyGroup, 0		;; case MD Only.
	xorlw	0x30
	btfsc	STATUS, Z
	goto	DSP_Rt_Ent031		;; case CD, Skip

	movf	DispCtrl, 0		;; DispCtrl -> W
	xorlw	DispCtrl_DcName		;; DiscName
	btfsc	STATUS, Z
	goto	GotoD2_Inform		;; DcName, Next is Inform

	movf	DispCtrl, 0		;; DispCtrl -> W
	xorlw	DispCtrl_TrName		;; TrackName
	btfsc	STATUS, Z
	goto	GotoD2_Inform		;; TrName, Next is Inform

DSP_Rt_Ent030:				;; case DispCtrl is "Inform" or "None"
	movf	DisplayMode, 0
	xorlw	Show_DcName		;; case DiscName
	movlw	0x08			;; set Display = 0x08
	btfsc	STATUS, Z
	movwf	Display

	movf	DisplayMode, 0
	xorlw	Show_TrName		;; case TrackName
	btfsc	STATUS, Z
	goto	DSP_Rt_Ent031		;; (Display=3)

	movf	DisplayMode, 0
	xorlw	Show_Clock		;; case Clock
	btfsc	STATUS, Z
	goto	DSP_Rt_Ent031		;; (Display=3)

	movf	DisplayMode, 0
	xorlw	Show_Time		;; case TrackTime
	btfsc	STATUS, Z
	goto	DSP_Rt_Ent031		;; (Display=3)

	btfss	DSPL_Run, 1		;; check DSPL_Run = 0000001X (initial flag)
	goto	DSP_Rt_Ent031		;; if not set, Skip to DSP_Rt_Ent031.

	bcf	DSPL_Run, 1		;; clear DSPL_Run = 0000001X (->0000000X)
	bsf	ResPeriod, 0 		;; (set ResPeriod = 1)

DSP_Rt_Ent033:
	movf	Display, 0
	xorlw	0x03			;; Display=3?
	btfsc	STATUS, Z
	goto	DSP_Rt_Ent032		;; case Display=3, goto DSP_Rt_Ent032.

	call	IssueSlaveBreak		;; Not Display=3, then call ISB.
	goto	ReceiveBreak		; Done, wait for next command


DSP_Rt_Ent031:				;; Go Display = 0x03 (Display TrackTime)
	clrf	SCRL_But		;; set SCRL_But=0 (1st)
	movlw	0x03
	movwf	Display
	bcf	DSPL_Run, 1		;; clear DSPL_Run = 0000001X (->0000000X)
					;; (maybe it's No need...)

DSP_Rt_Ent032:
	call	Int_Enaset		;; Enable Interrpt
	goto	ReceiveBreak		; Done, wait for next command

GotoD2_Inform
	movf	DisplayMode, 0
	xorlw	Show_Time		;;
	btfsc	STATUS, Z		;; case  DisplayMode= ShowTime,
	goto	DSP_Rt_Ent031		;; then DO NOT retry. (goto Display=3)

	movlw	DispCtrl_Inform		;; Show_TrName, or Show_DcName
	movwf	DispCtrl		;; DispCtrl= 0x0e
	movlw	0x02			;; set  Next State Number=2 (again)
	movwf	Display			;; 

	bsf	ResPeriod, 0 		;; (set ResPeriod = 1)
	call	IssueSlaveBreak

	goto	ReceiveBreak		; Done, wait for next command
	

Respond_SlavePoll_8:			;; Display shows Disc name
					;; [18,11,80,19,0a,00,00,00]
	movlw	0x18		;; 
	call	SendByte

	movlw	0x11		;; 
	call	SendByte

	movlw	0x80
	call	SendByte

	movlw	0x19			;; Show	Disc name
	call	SendByte

	call	Checksum_mid

	movlw	0x0a
	call	SendByte

	call	SendByte3_00

	call	Respond_End_R

	IFDEF	DiscName_Scrol
;;-------------------------------
	movlw	0x03			;; (No scroll)
	btfss	DSPL_ToggleC, 1		;; check 1bit position (Auto scroll OFF/ON)
	goto	Exit_ScrlSet		;; case Bit=0,  with No scroll

					;; case Bit=1,  with scroll
	clrf	SCRL_But		;; set SCRL_But=0 (1st)
	bsf	ResPeriod, 0 		;; (set ResPeriod = 1)
	movlw	0x0e			;; set  Next State Number=0x0e

Exit_ScrlSet:
	nop				;;
;;-------------------------------
	ELSE

	movlw	0x03
;;-------------------------------
	ENDIF   ;; <DiscName_Scrol>

	movwf	Display
	goto	DSP_Rt_Ent033


Respond_SlavePoll_9:			;; Display shows Track Time
					;; [18,11,80,09,0a,00,00,00]
	bcf	DSPL_Run, 0		;; set DSPL_Run flag OFF
					;;
	movlw	0x18			;; 
	call	SendByte

	movlw	0x11			;; 
	call	SendByte

	movlw	0x80
	call	SendByte

	movlw	0x09			;; Show	Track Time
	call	SendByte

	call	Checksum_mid

	movlw	0x0a
	call	SendByte

	call	SendByte3_00

	call	Respond_End_R

	movlw	0x03
	movwf	Display

	call	Int_Enaset		;; Enable Interrpt
	goto	ReceiveBreak


;;---				;; 'Track name' (Extra)
Respond_SlavePoll_a:		;;70,Tad,d9,xx,xx,xx,xx,xx,xx,xx,xx,01,(field)
	movlw	0x70			
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xD9
	call	SendByte

	movf	Dsp_Field, 0		;; copy to SubWork (work)
	movwf	SubWork2			;; 
	nop
	bcf	STATUS, C		;; clear C flag before rotation
	rlf	SubWork2, 1		;; rotate left 1 time (*2)-> REG
	nop
	rlf	SubWork2, 1		;; rotate left 2 time (*4)-> REG
	nop
	rlf	SubWork2, 0		;; rotate left 3 time (*8)-> W
	andlw	0xf8			;; mask with '11111000'

	addwf	TrackNamADDR, 0		;; TrackNamADDR + (8*field) -> W
	movwf	EepromChrAdd		;; set ;; TrackNamADDR

	call	SendEepromChrs

	movf	TrackNum_Dsp, 0		;; Track Number
	call	SendByte

	movf	Dsp_Field, 0		;; Dsp_Field -> W
	call	SendByte

	call	Respond_End_R

	goto	DSP_Rt_Ent


;;--				;; 'Disc name, (Extra)
Respond_SlavePoll_c:		;;70,Tad,dd,xx,xx,xx,xx,xx,xx,xx,xx,0f,(field)
	movlw	0x70			; 'CD name'
	call	SendByte

	movf	MyId, 0
	call	SendByte

	movlw	0xdd
	call	SendByte

	movf	Dsp_Field, 0		;; copy to SubWork (work)
	movwf	SubWork2		;; 
	nop
	bcf	STATUS, C		;; clear C flag before rotation
	rlf	SubWork2, 1		;; rotate left 1 time (*2)-> REG
	nop
	rlf	SubWork2, 1		;; rotate left 2 time (*4)-> REG
	nop
	rlf	SubWork2, 0		;; rotate left 3 time (*8)-> W
	andlw	0xf8			;; mask with '11111000'

	addwf	DiscNamADDR, 0		;; DiscNamADDR + (8*field) -> W

	movwf	EepromChrAdd		;; set W -> EepromChrAdd (tmp.)

;;-- Not extra long discname, but, just a re-displaying. ;; Aug. 21 2004
;;-- more 6 chars back.
	movlw	0x16			;; 22 chars back.

	subwf	EepromChrAdd, 1		;; EepromChrAdd - 0x10 -> EepromChrAdd (fixed)

	call	SendEepromChrs

	movf	DiskNum, 0 		;; Disc Number
	call	SendByte

	movf	Dsp_Field, 0		;; Dsp_Field -> W
	call	SendByte

	call	Respond_End_R

	goto	DSP_Rt_Ent

	IFDEF	DiscName_Scrol
;;-------------------------------
Respond_SlavePoll_e:		;; Manual Scroll [10,21,22,60/6a] (for MDX-5V101R)
	clrf	Checksum 		

	movlw	0x10			;; 
	call	SendByte

	movlw	0x21			;; 
	call	SendByte

	movlw	0x22			;;
	call	SendByte

	movlw	0x6a			;; released
	btfss	SCRL_But, 0		;;     SCRL_But=0/1=1st/2nd
	movlw	0x60			;; pressed
	call	SendByte

	call	Respond_End_R

	movlw	0x0e			;; pressed
	btfsc	SCRL_But, 0		;;     SCRL_But=0/1=1st/2nd
	goto	DSP_Rt_Ent031		;; released

	bsf	SCRL_But, 0		;; set SCRL_But=1 (next will be the 2nd)
	movwf	Display			;; 2nd time ([10,21,22,6a])
;;-------------------------------
	ENDIF ;;<DiscName_Scrol>
ManualScrl_Ent:
	bsf	ResPeriod, 0 		;; set ResPeriod = 1
	call	IssueSlaveBreak		;;

	goto	ReceiveBreak		;


	IFDEF	NextNext
;;--- NEXT NEXT----------------		;; Apr. 18 2004  (T)
;;--  Changed to send [Tad,11,b0,Num,ff,00,00,00]
Respond_SlavePoll_10:			;; label changed Apr. 18 2004 (T)
	movf	CurSource, 0
	call	SendByte

	movlw	0x11			;; 
	call	SendByte

	movlw	0xb0			;; Direct Num
	call	SendByte

	movf	CurDiscNum, 0		;; CurDiscNum (= new DiscNum)
	call	SendByte

	call	Checksum_mid

	movlw	0xff
	call	SendByte

	call	SendByte3_00

	call	Respond_End_R

	clrf	Display			;; set Next State Number=0
	clrf	ResPeriod		;; set ResPeriod=0
	bsf	PowDown, 0		;; PowerDown!!

	goto	ReceiveBreak		; Done, wait for next command
;;-------------------------------
	ENDIF	;;<NextNext>



	IFDEF	Internal_MD
;;--------------------------------	;; Jul. 25 2004 (T)
Respond_SlavePoll_20:		;; [77 MyId 8e c0 00 00 00 f0] (No magazine)
	movlw	0x77		;; 
	call	SendByte		;; Rad

	movf	MyId, 0			;; Tad
	call	SendByte

	movlw	0x8e			;; Cmd1
	call	SendByte

	movlw	0xc0			;; Cmd2
	call	SendByte

	call	Checksum_mid

	call	SendByte3_00

	movlw	0xf0			;; D4
	call	SendByte

	call	Respond_End_R

	clrf	Display			;; set Next State Number=0
	clrf	ResPeriod		;; set ResPeriod=0
	bsf	PowDown, 0		;; PowerDown!!

	goto	ReceiveBreak		; Done, wait for next command
;;--------------------------------
	ENDIF	;;Internal_MD

SendEepromChrs:
	call	RetEepromChr
	call	SendByte

	call	Checksum_mid

	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte
	
	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte

	call	RetEepromChr
	call	SendByte

	return

Checksum_mid:
	movf	Checksum, 0
	movwf	Count2

	movf	Checksum, 0
	call	SendByte

	movf	Count2, 0
	movwf	Checksum

	return

SendByte3_00:			;; successively "SendByte 0x00" by three times 
	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	movlw	0x00
	call	SendByte

	return

;;*****************************************************************************
;;----- End of display.asm
